﻿/**
パイプ。

勉強しなくては。

History:
	$(HIST_VER 1.100,
		$(HIST_NEW)
	)
*/
module etc.negui.process.pipe;

debug import std.stdio: wl = writefln;
debug(pipe) void main() {}

import std.array;
import std.contracts;

import win32.windows;

import etc.negui.system.base;
import etc.negui.environ.security;
import etc.negui.file.file;

///
class PipeException: NeGuiException {
	mixin MixInNeGuiException;
}

/**
*/
class PipeHandle: NeFile {
	///
	override this(HANDLE Handle, bool Suicide) {
		super(Handle, Suicide, false);
	}
	///
	override const typeof(this) dup() {
		return Duplicate(
			GetCurrentProcess(), GetCurrentProcess(),
			0, false, DUPOPTION.SAME_ACCESS
		);
	}
}

/**
*/
class Pipe: Raii {
	///
	PipeHandle reader, writer;

	///
	protected override void Kill() {
		//Exception e;
		auto StdHandles=[reader, writer];

		foreach(ref StdHandle; StdHandles) {
			delete StdHandle;
		}
	}

	
	/***/
	private this(HANDLE hRead, HANDLE hWrite, const SECURITY* Security, size_t Buffer) {
		CreatePipe(&hRead, &hWrite, Security ? Security.ptr: null, Buffer);

		this.reader = new PipeHandle(hRead, true);
		this.writer = new PipeHandle(hWrite, true);
		
		super(true);
	}
	///
	this(const ref SECURITY Security, size_t Buffer=0) {
		HANDLE hRead, hWrite;
		this(hRead, hWrite, &Security, Buffer);
	}
	///
	this(size_t Buffer=0) {
		HANDLE hRead, hWrite;
		this(hRead, hWrite, null, Buffer);
	}

	///
	ubyte[] read() {
		size_t OutputTotalBytesAvail;
		PeekNamedPipe(reader(), null, 0, null, &OutputTotalBytesAvail, null);
		if(OutputTotalBytesAvail) {
			auto Datas=new ubyte[OutputTotalBytesAvail];
			//ReadFile(reader(), Datas.ptr, Datas.length, &OutputTotalBytesAvail, null);
			auto Size=reader.read(Datas);
			return Datas[0 .. Size];
		}
		
		return null;
	}
	///
	bool write(const(ubyte)[] Data) {
		size_t WritedSize;
		if(WriteFile(writer(), cast(ubyte*)Data.ptr, Data.length, &WritedSize, null)) {
			return Data.length == WritedSize;
		}
		return false;
	}
	///
	void flush() {
		//FlushFileBuffers(writer());
		writer.flush();
	}
}
debug(pipe) unittest {
	auto p=new Pipe();
	assert(p.kill);
}

