﻿/**
History:
	$(HIST_VER 1.010,
		$(HIST_NEW)
	)
*/
module etc.negui.system.literal;

debug import std.stdio: wl = writefln;
debug(literal) void main() {}

/**
バッファサイズ。

History:
	$(HIST_VER 1.120,
		$(HIST_S STACK追加。)
	)
*/
enum BUFFER: size_t {
	INITIAL   = 8, /// 初期値。
	INCREMENT = 8, /// インクリメント。

	TEXT = 1024, /// 文字列取得用サイズ。
	STACK= 64, /// 初期スタックサイズ。
}
static assert(BUFFER.INITIAL);
static assert(BUFFER.INCREMENT);

/**
NeGui バージョン。
*/
enum VER: ushort {
	/**
	メジャーバージョン。

	[1-n]。
	*/
	MAJOR = 1,
	/**
	マイナーバージョン。

	[0-99]。

	History:
		$(HIST_VER 1.110,
			$(HIST_S マイナーバージョン情報の扱いを変更。)
		)
	*/
	MINOR = 12,
	/**
	特殊。

	$(TABLE
		$(TABLE_HEAD
			$(TABLE_ROW
				$(TABLE_COL_HEAD 番号)
				$(TABLE_COL_HEAD 意味)
			)
		)
		$(TABLE_BODY
			$(TABLE_ROW
				$(TABLE_COL_HEAD 0)
				$(TABLE_COL_DATA 通常)
			)
			$(TABLE_ROW
				$(TABLE_COL_HEAD 1)
				$(TABLE_COL_DATA 開発)
			)
		)
	)
	*/
	EX    = 0,
}
static assert(VER.MAJOR);
static assert(0 <= VER.MINOR && VER.MINOR <= 999);



